diff --git a/Documentation/tutorials/ovn-sandbox.rst b/Documentation/tutorials/ovn-sandbox.rst
index decc8abb39..4e40a96eb2 100644
--- a/Documentation/tutorials/ovn-sandbox.rst
+++ b/Documentation/tutorials/ovn-sandbox.rst
@@ -25,7 +25,7 @@
 OVN Sandbox
 ===========
 
-This tutorial shows you how to explore features using ``ovs-sandbox`` as a
+This tutorial shows you how to explore features using ``ovn-sandbox`` as a
 simulated test environment.  It's assumed that you have an understanding of OVS
 before going through this tutorial. Detail about OVN is covered in
 ovn-architecture_, but this tutorial lets you quickly see it in action.
@@ -33,10 +33,11 @@ ovn-architecture_, but this tutorial lets you quickly see it in action.
 Getting Started
 ---------------
 
-For some general information about ``ovs-sandbox``, see the Open vSwitch
-documentaion on ``ovs-sandbox``.
+``ovn-sandbox`` is derived from the Open vSwitch ``ovs-sandbox`` utility.
+For some general information about it, see the "Getting Started" section of
+`ovs-advanced`_ in the Open vSwitch documentation.
 
-``ovs-sandbox`` in the OVN repo includes OVN support by default.  To start it,
+``ovn-sandbox`` in the OVN repo includes OVN support by default.  To start it,
 you would simply need to run::
 
     $ make sandbox
@@ -62,7 +63,7 @@ Using GDB
 ---------
 
 GDB support is not required to go through the tutorial. See the "Using GDB"
-section of `ovs-advanced`_ in Open vSwitch documentation for more info.
+section of `ovs-advanced`_ in the Open vSwitch documentation for more info.
 Additional flags exist for launching the debugger for the OVN programs::
 
     --gdb-ovn-northd
@@ -72,9 +73,9 @@ Additional flags exist for launching the debugger for the OVN programs::
 Creating OVN Resources
 ----------------------
 
-Once you have ``ovs-sandbox`` running with OVN enabled, you can start using OVN
-utilities to create resources in OVN.  As an example, we will create an
-environment that has two logical switches connected by a logical router.
+Once you have ``ovn-sandbox`` running, you can start using OVN utilities to
+create resources.  As an example, we will create an environment that has two
+logical switches connected by a logical router.
 
 Create the first logical switch with one port::
 
@@ -123,7 +124,7 @@ View a summary of OVN's current logical configuration::
                 mac: "00:00:00:00:ff:02"
                 networks: ["11.0.0.1/24"]
 
-The ``tutorial`` directory of the OVS source tree includes a script
+The ``tutorial`` directory of the OVN source tree includes a script
 that runs all of the commands for you::
 
     $ ./ovn-setup.sh
diff --git a/NEWS b/NEWS
index 4d6ebea89e..141f1831c0 100644
--- a/NEWS
+++ b/NEWS
@@ -12,6 +12,7 @@ Post v24.03.0
     flow table id.
     "lflow-stage-to-oftable STAGE_NAME" that converts stage name into OpenFlow
     table id.
+  - Rename the ovs-sandbox script to ovn-sandbox.
 
 OVN v24.03.0 - 01 Mar 2024
 --------------------------
diff --git a/TODO_SPLIT.rst b/TODO_SPLIT.rst
index 5f11205bab..9c65f77d87 100644
--- a/TODO_SPLIT.rst
+++ b/TODO_SPLIT.rst
@@ -50,14 +50,6 @@ Immediate to Short-term tasks
   be removed from the tests/ directory, and we could reference the version in
   the ovs repo instead. There are many other files that this could be done with.
 
-* The ovs-sandbox is in a similar state to the tests directory. That is, the
-  tutorial/ directory contains a copy of the ovs-sandbox script. Rather than
-  copying the script wholesale, it probably makes more sense to refer to the
-  ovs version of the script from the ovn repo. Running the sandbox should
-  also be altered so that the base ovs-sandbox script doesn't do anything
-  ovn-related. Rather, the ovn repo can start the sandbox by calling into
-  ovs and then start the ovn parts after.
-
 * OVN code needs to be removed from the OVS repo. This should be mostly
   straightforward with a couple of exceptions. There is an include/ovn/
   directory in the ovs repo that should be moved to the ovn repo instead of
diff --git a/tutorial/automake.mk b/tutorial/automake.mk
index 29b1e006d2..631208639e 100644
--- a/tutorial/automake.mk
+++ b/tutorial/automake.mk
@@ -1,8 +1,8 @@
 EXTRA_DIST += \
-	tutorial/ovs-sandbox \
+	tutorial/ovn-sandbox \
 	tutorial/ovn-setup.sh \
 	tutorial/ovn-lb-benchmark.sh \
 	tutorial/ovn-lb-benchmark.py
 sandbox: all
 	cd $(srcdir)/tutorial && MAKE=$(MAKE) HAVE_OPENSSL=$(HAVE_OPENSSL) \
-		./ovs-sandbox -b $(abs_builddir) --ovs-src $(ovs_srcdir) --ovs-build $(ovs_builddir) $(SANDBOXFLAGS)
+		./ovn-sandbox -b $(abs_builddir) --ovs-src $(ovs_srcdir) --ovs-build $(ovs_builddir) $(SANDBOXFLAGS)
diff --git a/tutorial/ovs-sandbox b/tutorial/ovn-sandbox
similarity index 100%
rename from tutorial/ovs-sandbox
rename to tutorial/ovn-sandbox